// ###################################
// Implementierung der Klasse VeryLong
// ###################################

#include "VeryLong.h"
#include <stdlib.h>

VeryLong VeryLong::operator + (VeryLong Wert2)
{
	VeryLong temp;
	temp.Zahl=Zahl+Wert2.Zahl;
	return temp;
}

VeryLong VeryLong::operator + (unsigned int Wert2)
{
	VeryLong temp;
	temp.Zahl=Zahl+Wert2;
	return temp;
}

VeryLong VeryLong::operator - (VeryLong Wert2)
{
	VeryLong temp;
	temp.Zahl=Zahl-Wert2.Zahl;
	return temp;
}

VeryLong VeryLong::operator * (VeryLong Wert2)
{
	VeryLong temp;
	temp.Zahl=Zahl*Wert2.Zahl;
	return temp;
}

VeryLong VeryLong::operator * (unsigned int Wert2)
{
	VeryLong temp;
	temp.Zahl=Zahl*Wert2;
	return temp;
}

VeryLong VeryLong::operator / (VeryLong Wert2)
{
	VeryLong temp;
	temp.Zahl=Zahl/Wert2.Zahl;
	return temp;
}

VeryLong VeryLong::operator % (VeryLong Wert2)
{
	VeryLong temp;
	temp.Zahl=Zahl%Wert2.Zahl;
	return temp;
}

VeryLong VeryLong::operator & (VeryLong Wert2)
{
	VeryLong temp;
	temp.Zahl=Zahl&Wert2.Zahl;
	return temp;
}

bool VeryLong::operator < (VeryLong Wert2)
{
	return (Zahl<Wert2.Zahl);
}

bool VeryLong::operator > (VeryLong Wert2)
{
	return (Zahl>Wert2.Zahl);
}

bool VeryLong::operator == (VeryLong Wert2)
{
	return (Zahl==Wert2.Zahl);
}

bool VeryLong::operator != (VeryLong Wert2)
{
	return (Zahl!=Wert2.Zahl);
}

VeryLong::operator = (const int Wert)
{
	Zahl=Wert;
}

VeryLong::operator int()
{
	return Zahl;
}

void VeryLong::GetString(char *output)
{
	itoa(Zahl,output,10);
}

void VeryLong::SetString(const char *input)
{
	Zahl=atoi(input);
}

void VeryLong::GetBin(char *output, int Blocksize)
{
	char *Pointer;
	Pointer=(char*)&Zahl;

	for (int i=0;i<Blocksize;i++)
		output[i]=Pointer[Blocksize-i-1];
//Alt:	output[i]=Pointer[4-Blocksize+i];
//Neu:	output[i]=Pointer[4-Blocksize+i>1?2-Blocksize+i:6-Blocksize+i];

	output[Blocksize]='\0';
}

void VeryLong::SetBin(const char *input, int Blocksize)
{
	char *Pointer;
	Pointer=(char*)&Zahl;
	Pointer[0]='\0';
	Pointer[1]='\0';
	Pointer[2]='\0';
	Pointer[3]='\0';
	
	for (int i=0;i<Blocksize;i++)
		Pointer[Blocksize-i-1]=input[i];
//Alt:	Pointer[4-Blocksize+i]=input[i];
//Neu:	Pointer[4-Blocksize+i>1?2-Blocksize+i:6-Blocksize+i]=input[i];
}

int VeryLong::Len()
{
	if (Zahl>16777216)	return 3;
	if (Zahl>65536)		return 2;
	if (Zahl>256)		return 1;
						return 0;
}

VeryLong VeryLong::ModExp(VeryLong Potenz, 
                          VeryLong Modulo)
{
    // Beim 1. Aufruf den Standardwert neu setzen
    VeryLong ModuloStand;
	ModuloStand = (*this)%Modulo;

	VeryLong PotenzStand;
	PotenzStand=1;
	return ModExpIntern(Potenz, Modulo, ModuloStand, PotenzStand);
}

VeryLong VeryLong::ModExpIntern(VeryLong Potenz, 
                                VeryLong Modulo, 
                                VeryLong ModuloStand,
								VeryLong PotenzStand)
{
    // Auf Abbruchkriterium prfen
    if (Potenz>0)
    {
        // Neuen ModuloStand fr nchste Iterationsstufe berechnen
        // Quadrieren des Modulostandes, fr nchste Zweierpotenzsprung
        VeryLong ModuloStandNeu = 
               ((ModuloStand % Modulo) * (ModuloStand % Modulo)) % Modulo;

        // Prfen, ob diese Potenz fr den aktuellen Punkt 
        //     im 2er Verkor relevant ist
        if ((Potenz & PotenzStand)>0)
        {
            // Rest-Potenz berechnen
            VeryLong PotenzNeu = Potenz - (Potenz & PotenzStand);

            VeryLong A = ModuloStand;
            VeryLong B = ModExpIntern(PotenzNeu, 
                                      Modulo, 
                                      ModuloStandNeu,
									  PotenzStand*(unsigned int)2);

            return ((A % Modulo) * (B % Modulo)) % Modulo;
        }
        // Ansonten an die nchste Rekursionsstufe durchreichen
        else
        {
            return ModExpIntern(Potenz, 
                                Modulo, 
                                ModuloStandNeu,
								PotenzStand*(unsigned int)2);
        }
    }
    else
    {
        //Ende der Rekursion
		VeryLong temp;
		temp=1;
        return temp;
    }
}

int VeryLong::BytePosConvert(int Count, int Blocksize)
{
	int pos;

	pos=sizeof(Zahl)-Blocksize;

	pos+=Count;

	//Tauschen von Lo & Hi-Byte
	if (pos>1)
		pos-=2;
	else
		pos+=2;

	return pos;
}

VeryLong::VeryLong()
{
	Zahl=0;
}

VeryLong::~VeryLong()
{
}